'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * 在yonyou平台上实现的具体预处理类 , 需要监听cordova.deviceready事件
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Created by gengyb on 19/5/16.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

var _Mutants2 = require('./Mutants');

var _Mutants3 = _interopRequireDefault(_Mutants2);

var _AndroidRestore = require('./AndroidRestore');

var _AndroidRestore2 = _interopRequireDefault(_AndroidRestore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// import NativeConfig from './native-config';

var EsnBridge = function () {
    function EsnBridge() {
        _classCallCheck(this, EsnBridge);

        this.version = '1.0.0';
        this.initialized = false;
        this.isObject = function (o) {
            return Object.prototype.toString.call(o) === '[object Object]';
        };
    }

    _createClass(EsnBridge, [{
        key: 'ready',
        value: function ready(callback) {
            var _this = this;

            if (window.WebViewJavascriptBridge) {
                this.initWebViewJavascriptBridge(callback);
            } else {
                document.addEventListener('WebViewJavascriptBridgeReady', function () {
                    _this.initWebViewJavascriptBridge(callback);
                }, false);
            }
        }
    }, {
        key: 'initWebViewJavascriptBridge',
        value: function initWebViewJavascriptBridge(callback) {
            if (this.initialized) {
                console.log("init has been called.");
            } else {
                window.WebViewJavascriptBridge.init(function (message, responseCallback) {});
            }
            this.initialized = true;
            typeof callback === 'function' && callback();
        }
    }, {
        key: 'config',
        value: function config(parameters, callback) {
            if (!this.isObject(parameters)) {
                throw new Error('参数格式不正确');
            }
            if (!parameters.nonceStr || !parameters.timeStamp || !parameters.jssdkSignature || !parameters.agentId) {
                throw new Error('必要参数不存在');
            }
            parameters.fail = function (res) {
                console.error(res.error_description || 'config接口调用错误');
            };
            this.do('jsAuthority', parameters, callback);
        }
    }, {
        key: 'registerHandler',
        value: function registerHandler(parameters) {
            if (!this.isObject(parameters)) {
                throw new Error('参数格式不正确');
            }
            for (var key in parameters) {
                if (Object.prototype.hasOwnProperty.call(parameters, key)) {
                    window.WebViewJavascriptBridge.registerHandler(key, parameters[key]);
                }
            }
        }
    }, {
        key: 'do',
        value: function _do(action, parameters) {
            var _this2 = this;

            if (action === '' || typeof action !== 'string') {
                throw new Error('参数格式不正确');
            }
            if (!this.isObject(parameters)) {
                parameters = {};
            }
            try {
                window.WebViewJavascriptBridge.callHandler(action, parameters, function (res) {
                    // console.log('callback ====== ',parameters);
                    var resultData = {};
                    try {
                        if (!_this2.isObject(res)) {
                            res = JSON.parse(res);
                        }
                        if (res.error_code === '0') {
                            resultData = res.data;
                            // console.log('response ====== ','success',resultData);
                            typeof parameters.success === 'function' && parameters.success(resultData);
                        } else {
                            resultData.errCode = res.error_code;
                            resultData.errDescription = res.error_description;
                            // console.log('response ====== ','fail',resultData);
                            typeof parameters.fail === 'function' && parameters.fail(resultData);
                        }
                    } catch (e) {
                        // resultData.errCode = '1002';
                        // resultData.errDescription = 'data parse error';
                        typeof parameters.fail === 'function' && parameters.fail(resultData);
                    }
                    typeof parameters.complete === 'function' && parameters.complete();
                });
            } catch (e) {
                console.error('e=======', e);
                throw new Error('参数格式不正确');
            }
        }
    }]);

    return EsnBridge;
}();

window.YYEsnBridge = new EsnBridge();

var MutantsForYonyou = function (_Mutants) {
    _inherits(MutantsForYonyou, _Mutants);

    function MutantsForYonyou() {
        _classCallCheck(this, MutantsForYonyou);

        return _possibleConstructorReturn(this, (MutantsForYonyou.__proto__ || Object.getPrototypeOf(MutantsForYonyou)).call(this));
    }

    _createClass(MutantsForYonyou, [{
        key: '_ready',
        value: function _ready() {
            YYEsnBridge.ready(this._deviceReadyHandler.bind(this));
            // document.addEventListener('resume', this._deviceResumeHandler.bind(this));
            // document.addEventListener('pause', this._deviceSuspendHandler.bind(this));
        }
    }, {
        key: '_deviceReadyHandler',
        value: function _deviceReadyHandler() {
            // 获取 native config 信息
            // this._retrieveNativeConfig()
            //     .then(() => {
            //         //如果是安卓, 则需要查询restore状态及数据, 查询完成后, 在进行后续处理
            //         if(this.env.os == this.env.constant.os.android){
            //             AndroidRestore.ready(this._readyCallback.bind(this));
            //         }else{
            //             this._readyCallback();
            //         }
            //     })
            //     .catch(err => {
            //         console.error(err);
            //         this._readyCallback(err);
            //     })

            //如果是安卓, 则需要查询restore状态及数据, 查询完成后, 在进行后续处理
            // if(this.env.os == this.env.constant.os.android){
            //     AndroidRestore.ready(this._readyCallback.bind(this));
            // }else{
            this._readyCallback();
            // }
        }

        // _deviceResumeHandler(){
        //     this.emitter.emit(Mutants.EVENT_NAME.RESUME);
        // }

        // _deviceSuspendHandler(){
        //     this.emitter.emit(Mutants.EVENT_NAME.SUSPEND);
        // }

    }, {
        key: '_readyCallback',
        value: function _readyCallback(error) {
            this._isReady = true;
            this.emitter.emit(_Mutants3.default.EVENT_NAME.READY, error);
        }
    }, {
        key: 'isRestore',
        get: function get() {
            return _AndroidRestore2.default.isRestore;
        }
    }, {
        key: 'restorePluginData',
        get: function get() {
            return _AndroidRestore2.default.restorePluginData;
        }

        // _retrieveNativeConfig() {
        //     return new Promise((resolve, reject) => {
        //         const success = (resp) => {
        //             try {
        //                 if (typeof(resp) === 'string') {
        //                     resp = JSON.parse(resp);
        //                 }

        //                 if (resp.data && resp.data.platformExtension && resp.data.platformExtension !== '') {
        //                     // 解析 config 对象
        //                     NativeConfig.parseConfig(resp);
        //                     resolve(NativeConfig.instance);
        //                 }
        //                 else {
        //                     reject('没有得到正确的 config 数据.');
        //                 }
        //             }
        //             catch (err) {
        //                 reject(err.toString());
        //             }
        //         };

        //         const error = (error) => {
        //             reject(error);
        //         };

        //         if (window.cordova && window.cordova.exec) {
        //             // 有 cordova , 调用 native 插件读取 config 信息
        //             window.cordova.exec(success, error, 'Config', 'getConfig', []);
        //         }
        //         else {
        //             reject('没有 cordova 对象, 请确认 cordova 初始化是否正确.');
        //         }
        //     })
        // }

    }]);

    return MutantsForYonyou;
}(_Mutants3.default);

exports.default = MutantsForYonyou;